<?PHP

/**
 *	MySQL-Backup-Import ber die Shell
 *
 *	Systemvoraussetzung:
 *	Linux 
 *	PHP 4 >= 4.3.0, PHP 5
 *	MySQL
 *	Sed (Stream-Editor)
 *	wahlweise ZIP, BZIP2 oder TARGZ
 *
 *	Liest ein zuvor erstelltes Backup in eine bestehende Datenbank ein.
 *
 * 	LICENSE: GNU General Public License (GPL)
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2,
 *	as published by the Free Software Foundation.
 *
 *	@category   Datenbank
 *	@author     Damir Enseleit <info@selfphp.de>
 *	@copyright  2001-2006 SELFPHP
 *	@version    $Id: backupImportDB.php,v 0.10 2006/02/29 13:15:00 des1 Exp $
 *	@link       http://www.selfphp.de
 */


/**
 *	Konfiguration
 *
 *	Vervollstndigen Sie die bentigten Parameter in der Konfiguration
 *	mit den Werten fr Ihre MySQL-Datenbank. 
 * 	Die Integrittsprfung der angegebenen Backupdatei sorgt dafr, das nur
 *	original erstellte Backupdateien, die auch in der Logdatei aufgefhrt sind,
 *	eingelesen werden
 */

//	Datenbank Hostname oder IP
$self_config['dbhost'] = 'localhost';

//	Datenbank Username
$self_config['dbuser'] = 'dbuser';

//	Datenbank Passwort
$self_config['dbpassword'] = 'dbpassword';

//	Datenbank Name
$self_config['dbname'] = 'dbname';

//	ZIP-Format ('zip' , 'bzip2' , 'targz')
$self_config['zipformat'] = 'zip';

//	Name der Backupdatei
$self_config['backupfile'] = 'db152878808_2006-03-10_16-53-42.zip';

// Backupdatei nach Import lschen? - TRUE / FALSE
$self_config['backupdelete'] = FALSE;

// Entpackte SQL-Datei nach Import lschen? - TRUE / FALSE
$self_config['sqlfiledelete'] = FALSE;

// Backupverzeichnis
$self_config['verz'] = 'backup/';

// Integrittsprfung vornehmen? - TRUE / FALSE
// Wird beim Einlesen der Backupdatei in die Datenbank genutzt
$self_config['integritaet'] = TRUE;

// Name der Log-Datei fr Integrittsprfung
$self_config['logfile'] = 'logfile.log';


/**
 *	Programm - ab hier sollten Sie nichts mehr ndern!
 */
 
$zip_format['zip'] = 'zip';
$zip_format['bzip2'] = 'tar.bz2';
$zip_format['targz'] = 'tar.gz'; 

$compressFile = $self_config['verz'] . $self_config['backupfile'];
$checkCompressFile = TRUE;

/**
 *	Integrittsprfung - berprft anhand des Logfiles ob es sich um die
 *	original erstellte Backupdatei handelt. Somit soll gewhrleistet werden
 *	das die einzulesene Datei nicht manipuliert oder beim Senden beschdigt
 *	wurde. Sollte es sich um die Originaldatei handeln, so wird
 *	$checkCompressFile auf TRUE gesetzt.
 */
if($self_config['integritaet'])
{
	
	$checkCompressFile = FALSE;

	$handle = fopen ($self_config['logfile'],"r"); 
	while (($data = fgetcsv ($handle, 1000, "|")) !== FALSE) 
	{

		if($data[0] == $self_config['backupfile'])
		{
       if(md5_file($compressFile) == rtrim($data[1]))
       	$checkCompressFile = TRUE;
		}
	}
	fclose ($handle);

}


/**
 *	Backupdateien entkomprimieren
 *
 *	Entkomprimiert die zuvor erstellte Backupdatei in ein SQL-Datei
 *	
 *	-x entpackt die Datei
 *	-f Benutzt eine Archivdatei
 *	-d dekomprimieren
 *	-c In die Standard Ausgabe schreiben
 
 */
if($self_config['zipformat'] == "zip")
{
	
	$tarName .= '.' . $zip_format[$self_config['zipformat']];
	$shellBefehl = "unzip -x $compressFile";
	exec($shellBefehl);
	
}
else if($self_config['zipformat'] == "bzip2")
{
	
	$shellBefehl = "bzip2 -cd $compressFile | tar -xf -";
	exec($shellBefehl);
	
}
else
{
	
	$tarName .= '.' . $zip_format[$self_config['zipformat']];
	$shellBefehl = "gzip -cd $compressFile | tar -xf -";
	exec($shellBefehl);
	
}


// MySQL-File zum Einlesen in die Datenbank
$pattern = '/'.$zip_format[$self_config['zipformat']].'/';
$sqlFile = @preg_replace($pattern,"",$compressFile) . 'sql';


/**
 *	Lscht die zuvor erstellte nicht komprimierte Backupdatei (*.sql)
 */
if($self_config['backupdelete']) 
	@unlink($compressFile);


/**
 *	Backupimport der Datenbank
 *
 *	Fhrt das Backup der Datenbank aus. MySQL hat die	Angewohnheit 
 *	seine eigenen erstellten Kommentare in einem Dump beim Einlesen
 *	als Fehler zu interpretieren. Aus diesem Grund entfernen wir die
 *	Kommentare mittels sed "s/^--.*$//" um unser Backup auch wieder
 *	ohne Probleme einlesen zu knnen. Der Dump wird in das aktuelle
 *	Arbeitsverzeichnis kopiert.
 *	Z.B. als db152878808_2006-03-07_08-49-48.sql
 **/

if(@file_exists($sqlFile) && $checkCompressFile == TRUE)
{ 
	$mysqlDump = 'mysql ';
	$mysqlDump .= '--host="' . $self_config['dbhost'] . '" ';
	$mysqlDump .= '--user="' . $self_config['dbuser'] . '" ';
	$mysqlDump .= '--password="' . $self_config['dbpassword'] . '" ';
	$mysqlDump .= $self_config['dbname'] . ' < ' . $sqlFile;
	exec($mysqlDump);
}


/**
 *	Lscht die zuvor entpackte Backupdatei (*.sql)
 */
if($self_config['sqlfiledelete']) 
	@unlink($sqlFile);

?>
